;ENTRY.ASM	31-Oct-2008	Boreal		loren.blaney@idcomm.com
;
;                                ͻ ͻ           
;                           o                      
;                ͹   ͻ     ͼ   ɼ       Ŀ Ŀ
;                                               
;                   ͼ ͹     ͼ                
;                Ŀ        compo                
;                       ͼ                        o
;                 Ŀ Ŀ   Ŀ Ŀ Ŀ Ŀ   Ŀ ڿ
;                   Ŀ                   
;                                  
;   
;This displays an ANSI image (in hopefully just a few bytes)
; Assemble with:
;  tasm example
;  tlink /t example

cseg	segment
	assume	cs:cseg, ds:cseg, ss:cseg, es:cseg

	.486
	org	100h
;(ax=0, ch=0)
start:	mov	al, 03h		 ;clear bottom lines of screen (and enable
	int	10h		 ; access to display memory under Windows XP)

	push	0B800h		 ;es:[di] points to display memory
	pop	es
	xor	di, di

;Compression codes
; 00..0F is the number of space characters -1 (20)
; 10..1F is the number block characters +0F (DB)
; 22..2F is the attribute in range 02..0F
; 30..3F is the number of bottom blocks +2F (DC)
; 40..42 characters B0..B2
; 43..45 characters DD..DF
; 46	 character FE
; 47	 attribute follows, not in range 02..0F
; 7E	 end marker
; other codes are simply the characters themselves
;
;Register usage:
; al = character code
; ah = current attribute
; bx = index to Image0
; cx = counter
; di = index to screen

	mov	ah, 07h		;attribute
d00:	call	next

	cmp	al, 0Fh		;00..0F spaces (20)
	ja	d10
	mov	cl, 20h		;space
	jmp	d75
d10:
	cmp	al, 1Fh		;10..1F blocks (DB)
	ja	d20
	mov	cl, 0DBh	;block
	jmp	d75
d20:
	cmp	al, 21h		;space or exclamation point
	jbe	d80
d30:
	cmp	al, 2Fh		;22..2F attribute in range 02..0F
	ja	d40
	and	al, 0Fh
	jmp	d72
d40:
	cmp	al, 3Fh		;30..3F bottom blocks (DC)
	ja	d50
	mov	cl, 0DCh
	jmp	d75
d50:
	cmp	al, 42h		;40..42 characters B0..B2
	ja	d53
	add	al, 0B0h-40h
	jmp	d80
d53:
	cmp	al, 45h		;43..45 characters DD..DF
	ja	d56
	add	al, 0DDh-43h
	jmp	d80
d56:
	cmp	al, 46h		;46 character FE
	ja	d60
	mov	al, 0FEh
	jmp	d80
d60:
	cmp	al, 7Eh		;7E end
	je	d99
d70:
	cmp	al, 47h		;47 attribute follows, not in range 02..0F
	jne	d80
	call	next

d72:	mov	ah, al
	jmp	d90

d75:	and	al, 0Fh		;convert code into repetition count
	inc	ax
	xchg	al, cl
;(ch=0)
	rep
d80:	stosw			;write character to screen; es:[di++] <- ax
d90:
	jmp	d00		;loop until terminator character
d99:
	mov	cl, 80		;output a line of top blocks with brown
	mov	ax, 06DFh	; foreground and black background
	rep stosw		;es:[di++] <- ax; cx--

	xchg	ax, cx		;wait for a keystroke (ah:=0)
	int	16h
	ret

;-------------------------------------------------------------------------------
;Get next byte
;
next:	mov	cx, 7
n05:	mov	bx, ImageEnd-Image0-1
n07:	rcl	byte ptr [bx+Image0], 1
	dec	bx
	jns	n07
	loop	n05
	mov	al, Image0
	and	al, 7Fh
;(cx=0)
	ret


Image0	db	0
Image	db	00Eh,09Ah,008h,0F5h,0CCh,04Ch,0B1h,01Eh,03Ch,07Ah,068h,030h,007h,02Eh,060h,075h
	db	080h,0F1h,0E3h,093h,041h,081h,008h,02Ch,028h,050h,002h,02Eh,033h,016h,029h,031h
	db	0E1h,0D3h,0B2h,050h,0C8h,07Ah,068h,030h,040h,042h,005h,006h,00Ch,020h,050h,060h
	db	003h,05Ch,04Ah,02Bh,018h,0A0h,018h,011h,060h,044h,078h,034h,0ECh,063h,0F7h,003h
	db	01Fh,0C4h,008h,030h,048h,028h,065h,016h,029h,006h,022h,093h,042h,083h,002h,00Ch
	db	010h,010h,020h,085h,082h,011h,074h,058h,0A5h,0E2h,0C5h,01Eh,005h,03Bh,008h,0FDh
	db	0C0h,047h,0F1h,002h,00Ch,018h,030h,0A1h,010h,084h,055h,043h,018h,0B1h,048h,030h
	db	002h,09Ah,000h,048h,030h,0A0h,0C1h,083h,00Ah,008h,068h,010h,020h,08Fh,00Ah,0BDh
	db	088h,078h,0FFh,0C0h,047h,0EEh,042h,03Fh,088h,010h,061h,010h,082h,042h,011h,0B5h
	db	00Ch,022h,090h,000h,09Ah,004h,010h,030h,060h,041h,085h,00Ah,000h,008h,030h,045h
	db	040h,01Eh,001h,07Bh,002h,0ACh,002h,047h,0FEh,002h,03Fh,088h,010h,061h,011h,084h
	db	079h,044h,032h,000h,093h,040h,081h,004h,004h,008h,024h,020h,040h,082h,03Ch,062h
	db	0F8h,084h,022h,0C5h,023h,016h,029h,010h,071h,0FCh,044h,081h,004h,0F9h,025h,010h
	db	0C8h,001h,04Dh,002h,008h,028h,010h,048h,040h,081h,004h,05Ah,0F8h,0ACh,048h,030h
	db	016h,041h,089h,016h,024h,0C1h,047h,0F1h,010h,084h,012h,011h,0F8h,046h,0A5h,097h
	db	09Fh,040h,01Ah,077h,001h,0A1h,097h,00Eh,03Ch,0B1h,0A3h,0F8h,022h,0A2h,019h,000h
	db	009h,0A0h,004h,085h,006h,014h,018h,010h,045h,0AFh,08Ah,0C0h,0A3h,020h,06Ch,049h
	db	0B0h,003h,014h,0A0h,015h,004h,063h,0F8h,084h,07Ch,092h,088h,064h,003h,026h,084h
	db	002h,011h,008h,030h,045h,0AFh,08Ah,00Ah,029h,0F2h,0ECh,040h,028h,08Bh,014h,0F9h
	db	028h,064h,003h,026h,082h,002h,011h,008h,050h,044h,0A8h,06Ah,009h,07Ch,053h,0E5h
	db	063h,0FFh,085h,006h,03Fh,072h,009h,0D9h,028h,08Ah,042h,02Ah,076h,00Ah,022h,0C5h
	db	04Eh,0C0h,002h,088h,0A5h,0E1h,090h,00Ch,09Ah,00Ch,022h,000h,021h,041h,00Ch,0A1h
	db	081h,015h,0D2h,030h,0F0h,0E1h,0E5h,041h,026h,000h,097h,09Fh,025h,01Fh,0FCh,028h
	db	030h,023h,0F7h,022h,002h,03Fh,088h,010h,053h,0B2h,08Fh,0E2h,004h,008h,029h,0D8h
	db	045h,050h,0C0h,0B4h,032h,001h,093h,010h,084h,042h,004h,028h,041h,054h,011h,05Dh
	db	023h,00Eh,0CDh,09Bh,0FBh,0E5h,0CBh,0B9h,00Ah,082h,020h,097h,0C5h,03Eh,046h,03Fh
	db	0F8h,050h,060h,047h,0EEh,042h,03Fh,088h,011h,0FBh,090h,08Fh,0E2h,004h,008h,010h
	db	060h,040h,082h,09Eh,02Ch,055h,00Ch,00Bh,043h,020h,015h,034h,028h,040h,020h,041h
	db	021h,008h,02Ah,082h,030h,048h,0C2h,084h,042h,011h,018h,044h,021h,004h,05Fh,016h
	db	02Ch,07Fh,0F0h,060h,090h,084h,06Ah,014h,018h,011h,0FBh,091h,08Fh,0E2h,004h,008h
	db	009h,0E2h,0C5h,000h,0A1h,091h,088h,064h,002h,0A6h,021h,006h,000h,008h,024h,021h
	db	005h,050h,042h,014h,008h,050h,0A0h,0C2h,021h,006h,011h,008h,044h,021h,003h,060h
	db	044h,002h,072h,051h,0FFh,0C5h,082h,066h,014h,018h,011h,0FBh,091h,04Fh,014h,002h
	db	083h,0D0h,0C8h,005h,04Dh,008h,001h,008h,030h,048h,041h,00Ah,0A2h,014h,018h,010h
	db	061h,041h,083h,00Ah,004h,028h,050h,048h,041h,007h,008h,084h,028h,02Ch,013h,0C5h
	db	023h,01Fh,0FCh,013h,010h,0A0h,0C7h,0EEh,041h,03Ch,055h,00Ch,08Fh,0C3h,020h,011h
	db	034h,022h,000h,020h,080h,081h,00Ah,008h,055h,010h,0A0h,040h,081h,006h,004h,018h
	db	030h,020h,0C1h,083h,00Ah,008h,038h,030h,0A0h,0C0h,085h,009h,082h,078h,0B1h,0FFh
	db	0C1h,033h,00Ah,00Ch,004h,0ECh,080h,028h,08Bh,016h,02Ch,053h,050h,0C8h,003h,04Dh
	db	008h,080h,008h,050h,020h,040h,085h,002h,000h,045h,010h,060h,000h,081h,002h,004h
	db	008h,000h,020h,041h,081h,006h,000h,038h,010h,060h,000h,083h,006h,00Ch,010h,00Bh
	db	0E2h,0C5h,02Fh,01Fh,0FCh,018h,000h,023h,0F7h,022h,006h,03Fh,088h,010h,020h,041h
	db	04Eh,0C0h,002h,088h,0B1h,062h,0C5h,08Bh,014h,094h,032h,000h,093h,042h,084h,006h
	db	00Ch,008h,000h,021h,041h,081h,000h,01Ah,088h,000h,060h,040h,080h,002h,000h,008h
	db	010h,000h,040h,080h,00Eh,004h,000h,030h,060h,040h,080h,015h,07Ch,058h,0B1h,062h
	db	0C5h,04Fh,014h,09Ch,07Fh,010h,020h,040h,081h,002h,03Fh,072h,011h,0FCh,040h,081h
	db	006h,00Ch,07Eh,0E4h,093h,0B2h,002h,0A2h,028h,004h,0CCh,020h,041h,08Fh,083h,09Eh
	db	034h,0D0h,020h,0C2h,067h,002h,004h,006h,043h,05Fh,0B6h,08Fh,0A2h,02Ch,054h,0CDh
	db	063h,0F6h,07Fh,01Fh,07Ch,05Fh,0DFh
ImageEnd equ $

cseg	ends
	end	start
